stages:
    - build
    - test
    - deploy

build_job:
    services:
        - docker:dind
    image: docker
    stage: build
    before_script:
        - docker login $CI_REGISTRY -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD
    script:
        - docker pull $CI_REGISTRY/vitaly.vasiliev/flatrix:latest || true      
        - docker build --cache-from $CI_REGISTRY/vitaly.vasiliev/flatrix:latest -t $CI_REGISTRY/vitaly.vasiliev/flatrix:$CI_BUILD_REF -t $CI_REGISTRY/vitaly.vasiliev/flatrix:latest .
        - docker push $CI_REGISTRY/vitaly.vasiliev/flatrix:$CI_BUILD_REF
        - docker push $CI_REGISTRY/vitaly.vasiliev/flatrix:latest
        
test_job:
    services:
        - name: docker:dind
          alias: localhost
    image: docker
    stage: test
    before_script:
        - apk add --update curl && rm -rf /var/cache/apk/*
    script:
        - docker run -d --name flatris -p3000:3000 $CI_REGISTRY/vitaly.vasiliev/flatrix:latest
        - sleep 15
        - curl localhost:3000

deploy_job:
    image: alpine/k8s:1.13.12
    stage: deploy
    script:
      - kubectl config set-cluster skillbox --server="$KUBE_URL" --insecure-skip-tls-verify=true
      - kubectl config set-credentials gitlab-admin --token="$KUBE_TOKEN"
      - kubectl config set-context default --cluster=skillbox --user=gitlab-admin
      - kubectl config use-context default
      - sed -i "s/__VERSION__/gitlab-$CI_COMMIT_SHORT_SHA/" Kubernetes/flatris-deployment.yaml
      - sed -i "s/__VERSION__/gitlab-$CI_COMMIT_SHORT_SHA/" Kubernetes/flatris-service.yaml
      - kubectl apply -f Kubernetes/flatris-deployment.yaml
      - kubectl apply -f Kubernetes/flatris-service.yaml
